/* Lezione quicksort, esericizio 4:
   Ordinare un array A di stringhe, alfabeticamente.
   Poi, implementare la ricerca binaria su di esso. */
#include <stdio.h>
#include <stdlib.h>

#define MAXSTRLEN 1000


/* Leggiamo un array di tringhe di lunghezza data. */
char **leggi ( int N ) 
{
   int i;
   char **array = malloc(sizeof(char *)*N );
   for ( i = 0; i < N; i++ ) 
   {
      array[i] = malloc(sizeof(char)*(MAXSTRLEN+1));
      scanf("%s", array[i]); 
   }
   return array;
}

/* Implementazione della ricerca binaria con stringhe. */
int cerca( char **array, int N, char * domanda )
{
    int r = N;
    int l = 0;
    int mid, controllo ;

    while ( r - l > 0 ) 
    {
       /* Punto di mezzo */
       mid = (r+l)/2;
       controllo = strcmp(domanda, array[mid] ); 
       if ( controllo == 0 ) 
           return mid;
       else if (controllo < 0 ) 
           r = mid;
       else
           l = mid; 
    }

    return -1;
}

/* Main */
main()
{
   int i, N, d;
   char **array;
   char domanda[MAXSTRLEN];

   scanf("%d", &N);
   array = leggi( N );

   while ( 1 ) { 
     scanf("%d", &d );
     if ( d == 0 ) break;

     scanf("%s", domanda );
     printf("%d\n", cerca( array, N, domanda ) );
   }

   return 0;
}
